'*********************************************************
' Zanme programovat v jazyce VB.NET
' (c) 2002 Computer Press a Lubo Brha
' Nsledujc kd mete pouvat jak, kdy a kde chcete.
' Funguje-li, napsal jej (lb), nefunguje-li, pak nevm kdo 
' to zpsobil :-)
' Projekt: Celsius
'*********************************************************
Option Strict On

Module Module1

    ' funkce pevede stupn Fahrenheita na Celsiovu stupnici
    Function ToCelsius(ByVal degF As Decimal) As Decimal
        ToCelsius = ((degF - 32) * (5@ / 9))
    End Function

    ' funkce pevede stupn Celsia do Fahrenheitovi stupnice
    Function ToFahrenheit(ByVal degC As Decimal) As Decimal
        Return (((9@ / 5) * degC) + 32)
    End Function

    ' procedura pozastav bh konzolovho programu do doby, ne uivatel
    ' stiskne klvesu Enter.
    ' Navc jako bonbnek zobraz npovdu, co m uivatel udlat pro
    ' pokraovn bhu programu.
    Sub Pause(Optional ByVal message As String = "")

        If Len(message) = 0 Then
            message = "Pro pokraovn stisknte klvesu <Enter>."
        End If

        ' zobraz npovdu pro uivatele
        Console.WriteLine(message)
        ' pozastav bh programu
        Console.ReadLine()

    End Sub

    ' zobraz tip na zklad pedan hodnoty ve stupnch Celsia
    Sub DisplayTip(ByVal degC As Decimal)
        Dim tip As String  ' tip

        ' vyber typ na zklad hodnoty;
        ' rozsahy hodnot a tipy si upravte podle svch preferenc
        Select Case degC
            Case Is > 30
                tip = "m mn obleen, tm lpe :-)"
            Case Is >= 15
                tip = "Cokoli vzdunho se bude hodit."
            Case Is < 15
                tip = "Prevence ped nachlazenm bude namst."
        End Select

        ' zobraz tip
        DisplayMessage("Tip:" & tip)

    End Sub

    ' funkce nejprve zobraz hlen a pot ek na vstup od uivatele
    ' pokud uivatel zad na zatku nebo na konci vstupu mezery, jsou 
    ' tyto bl znaky ignorovny.
    Function UserInput(ByVal hlaseni As String) As String
        Dim line As String  ' vstup od uivatele

        ' zobraz hlen pro uivatele
        Console.WriteLine(hlaseni)
        ' pok na vstup
        line = Console.ReadLine()

        ' vrt zpracovan vstup jako etzec
        UserInput = Trim(line)
    End Function

    ' jednoduch funkce pro zobrazen hlen do konzole
    Sub DisplayMessage(ByVal hlaseni As String)

        ' zobraz hlen
        Console.WriteLine(hlaseni)

    End Sub

    Sub Main()
        Dim degF As Decimal  ' poet stup Fahrenheita
        Dim degC As Decimal  ' poet stup Celsia
        Dim temp As String   ' pomocn promnn

        Dim failed As Boolean
        Do
            failed = False
            ' ulo vstup od uivatele do pomocn promnn
            ' pokud uivatel nic nezadal, ukonci program.
            temp = UserInput("Zadejte poet stup Fahrenheita:")
            If Len(temp) = 0 Then Exit Sub

            ' konverze vstupu na selnou hodnotu
            Try
                degF = CDec(temp)
            Catch e As System.InvalidCastException
                failed = True
                DisplayMessage(temp & " nen pevoditeln na slo.")
            End Try
        Loop While failed

        ' pevod na stupn Celsia
        degC = ToCelsius(degF)
        DisplayMessage(degF & " je " & degC & " stup Celsia.")
        Pause()   ' pozastaven programu

        ' pevod zpt na stupn Fahrenheita
        degF = ToFahrenheit(degC)
        DisplayMessage(degC & " je " & degF & " stup Fahrenheita")
        Pause("K ukonen programu pouijte klvesu <Enter>.")   ' pozastaven programu
    End Sub

End Module
